Imports System.ComponentModel

Public Class frmDirectBinding
    'Das Interface "INotifyPropertyChanged" stellt einen Benachrichtigungsmechanismus, den das
    ' DataBinding benutzen kann...
    Implements INotifyPropertyChanged

    '...nmlich dieses Event
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As PropertyChangedEventArgs) _
       Implements INotifyPropertyChanged.PropertyChanged

    Private _Brightness As Byte
    Public Property Brightness() As Byte
        Get
            Return _Brightness
        End Get
        Set(ByVal Value As Byte)
            _Brightness = Value

            ' drei gleiche Farbkomponenten ergeben einen Grauwert in angegebener Helligkeit
            MyBase.BackColor = Color.FromArgb(Value, Value, Value)

            'Alle angeschlossenen Bindings benachrichtigen, da Brightness gendert wurde
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Brightness"))
        End Set
    End Property

    Private Sub frmDirectBinding_Load(ByVal sender As Object, ByVal e As EventArgs) _
          Handles MyBase.Load
        TextBox1.DataBindings.Add("Text", Me, "Brightness", False, DataSourceUpdateMode.OnPropertyChanged)

        ' DataSourceUpdateMode.OnValidation:  Textnderungen werden erst nach Validierung wirksam
        '                                                              (i.A. nach Fokusverlust)   
        ' nullValue:                          hat bei Valuetypen (hier: Byte) keine Wirkung
        ' formatString "c":                   spaeshalber Werte als Whrung (Currency) anzeigen
        TextBox2.DataBindings.Add( _
            "Text", Me, "Brightness", formattingEnabled:=True, _
            updateMode:=DataSourceUpdateMode.OnValidation, _
            nullValue:=Nothing, formatString:="c")
        HScrollBar1.DataBindings.Add( _
            "Value", Me, "Brightness", False, DataSourceUpdateMode.OnPropertyChanged)
        Me.Brightness = 127
    End Sub

End Class
